//+------------------------------------------------------------------+
//|                                      SovetnikSoundStochastic.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//           (NizUroven) 
//      (VerhUroven)
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern int  MaxRisk=2;
extern int  TakeProfit=14;
extern int  StopLoss=0;
double newLot=0;
extern string  = "Sound - , Allert -  ";
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
extern int VerhUroven=75;  // .
extern int NizUroven=25;  //  . 
extern bool Sound = true;  //  
extern string ZvukFileBuy = "alert.wav";                 
extern string ZvukFileSell = "alert.wav";                 
extern bool Allert = true; //   

int pre_signal,Type,z = 0;

double M_0, M_1,Lot2,               //  MAIN  0  1 
   S_0, S_1;               //  SIGNAL  0  1
   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
{
if(VerhUroven<NizUroven) 
{z=VerhUroven;
VerhUroven=NizUroven;
NizUroven=z;
}
return(0);}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   {if(DayOfWeek()==0 || DayOfWeek()==6) return(0); //    
 if(!IsTradeAllowed()) return(0); 		//     
 int Count=0;

 

//--------------------------------------------------------------------
   //    ..
   M_0=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_MAIN,  0);// 0 
   M_1=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_MAIN,  1);// 1 
 //  S_0=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,0);// 0 
 //  S_1=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_SIGNAL,1);// 1 
//--------------------------------------------------------------------
   //  
 //  if(M_1 < S_1 && M_0>=S_0) //     D  
//        Alert("  . ."); //  

  // if(M_1 > S_1 && M_0<=S_0) //     D  
//      Alert("  . ."); //  

   
         if(pre_signal <= 0 && M_1<NizUroven && M_0 >=NizUroven) //   NizUroven  
                { 
     CloseOrder();           
   Lot2=GetLot(MaxRisk);
 if(Lot2==0) {Alert(" !");return(0);}
NewOrder(OP_BUY,Lot2);
       
                //if(Sound) PlaySound(ZvukFileBuy);
                //if(Allert) Alert("Stochastic  BUY! ",Symbol()," ", Period());
                 
                 pre_signal =  1; 
               }
             if(pre_signal >= 0 && M_1>VerhUroven && M_0<=VerhUroven) //   VerhUroven  
               { 

CloseOrder();
Lot2=GetLot(MaxRisk);
 if(Lot2==0) {Alert(" !");return(0);}
NewOrder(OP_SELL,Lot2);

                //if(Sound) PlaySound(ZvukFileSell);
              //if(Allert) Alert("Stochastic  SELL! ",Symbol()," ", Period());
                pre_signal = -1;    
               }                  





//----
   return(0);
  }
//+------------------------------------------------------------------+
double GetLot (int Risk)		//"  "
{double Free    =AccountFreeMargin();
 double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Min_Lot =MarketInfo(Symbol(),MODE_MINLOT);	 //    
 double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);	//  .
 double Step    =MarketInfo(Symbol(),MODE_LOTSTEP);	//    .
 double Lot     =MathFloor(Free*Risk/100/One_Lot/Step)*Step;	//     ,  2 
 if(Lot<Min_Lot) Lot=Min_Lot;
 if(Lot>Max_Lot) Lot=Max_Lot;
 if(Lot*One_Lot>Free) return(0.0);
return(Lot);}
//+------------------------------------------------------------------+
int NewOrder(int Cmd,double Lot)      // "  "
{double TP=0; //
 double SL=0; //
 double PR=0; //
 int tic;
 while(!IsTradeAllowed()) Sleep(100);
 if(Cmd==OP_BUY)
   {PR=Ask;
    if(TakeProfit>0) TP=Ask+TakeProfit*Point;
    if(StopLoss>0) SL=Ask-StopLoss*Point;
    tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,Green);
    }
 if(Cmd==OP_SELL)
   {PR=Bid;
    if(TakeProfit>0) TP=Bid-TakeProfit*Point;
    if(StopLoss>0) SL=Bid+StopLoss*Point;
    tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,Red);
    }
 
 if(tic<0) Print("  : ",GetLastError());       // GetLastError()    .
return(tic);}
//+------------------------------------------------------------------+
void CloseOrder()  ////  
{double PR=0;
 while(!IsTradeAllowed()) Sleep(100);
 if(OrderType()==OP_BUY)  PR=Bid;
 if(OrderType()==OP_SELL) PR=Ask;
 if(!OrderClose(OrderTicket(),OrderLots(),PR,3,CLR_NONE))
   Print("  : ",GetLastError());
return;}
//+------------------------------------------------------------------+